#!/bin/bash


which timeout 2>&1 >/dev/null && DIG_TIMEOUT_CMD="timeout -k3 2"
which dig 2>&1 >/dev/null && DIG_CMD="$DIG_TIMEOUT_CMD dig"

argv=($*)
argc=${#argv[@]}
i=0
for ((j=0;j<argc;j++)); do
	argNUM="`printf %d ${argv[$j]} 2>/dev/null`"
	if [[ "$argNUM" == "" ]]; then continue; fi
	argv[(i++)]=${argNUM}
done	
argc=${#argv[@]}

while read NETWORK; do

        REVNET=`echo "$NETWORK" | ( IFS='./' read a b c d e; echo "$d.$c.$b.$a" )`
        DIG_OUT=`$DIG_CMD +short ${REVNET}.dnsbl.dronebl.org` || continue
        if [[ "$DIG_OUT" == "" ]]; then continue; fi
        for i in $DIG_OUT; do
                DNSBL_CODE=`echo $i | (IFS='.' read a b c d; echo "$d")`
		if [[ "$DNSBL_CODE" == "" ]]; then continue; fi
		echo -n "$NETWORK $DNSBL_CODE " 
		unset argNUM
		for ((j=0;j<argc;j++)); do
			if (( argv[$j] == DNSBL_CODE )); then argNUM=${argv[$j]}; break; fi
		done
		if [[ ! -z "$argNUM" ]] && (( argNUM == DNSBL_CODE )); then echo "matched"; break; fi
				
                case $DNSBL_CODE in
		2) echo "Sample";;
		3) echo "IRC Drone";;
		5) echo "Bottler";;
		6) echo "Unknown spambot or drone";;
		7) echo "DDOS Drone";;
		8) echo "SOCKS Proxy";;
		9) echo "HTTP Proxy";;
		10) echo "ProxyChain";;
		11) echo "Web Page Proxy";;
		12) echo "Open DNS Resolver";;
		13) echo "Brute force attackers";;
		14) echo "Open Wingate Proxy";;
		15) echo "Compromised router / gateway";;
		16) echo "Autorooting worms";;
		17) echo "Automatically determined botnet IPs (experimental)";;
		18) echo "DNS/MX type hostname detected on IRC";;
		19) echo "Abused VPN Service";;
		255) echo "Unknown";;
		*) echo "Unlisted type";;
                esac
        done
done


